## GTlsInteraction GTlsInteraction — Interaction with the user during TLS operations. |

## Functions

GTlsInteractionResult | g_tls_interaction_invoke_ask_password ()
GTlsInteractionResult | g_tls_interaction_invoke_request_certificate ()
GTlsInteractionResult | g_tls_interaction_ask_password ()
void | g_tls_interaction_ask_password_async ()
GTlsInteractionResult | g_tls_interaction_ask_password_finish ()
GTlsInteractionResult | g_tls_interaction_request_certificate ()
void | g_tls_interaction_request_certificate_async ()
GTlsInteractionResult | g_tls_interaction_request_certificate_finish ()

## Types and Values

| GTlsInteraction
enum | GTlsInteractionResult
enum | GTlsCertificateRequestFlags
struct | GTlsInteractionClass

## Object Hierarchy

        GEnum
        ├── GTlsCertificateRequestFlags
        ╰── GTlsInteractionResult
        GObject
        ╰── GTlsInteraction

## Includes

    #include <gio/gio.h>

## Description

GTlsInteraction provides a mechanism for the TLS connection and database code to interact with the user. It can be used to ask the user for passwords.

To use a GTlsInteraction with a TLS connection use `g_tls_connection_set_interaction()`.

Callers should instantiate a derived class that implements the various interaction methods to show the required dialogs.

Callers should use the 'invoke' functions like `g_tls_interaction_invoke_ask_password()` to run interaction methods. These functions make sure that the interaction is invoked in the main loop and not in the current thread, if the current thread is not running the main loop.

Derived classes can choose to implement whichever interactions methods they'd like to support by overriding those virtual methods in their class initialization function. Any interactions not implemented will return `G_TLS_INTERACTION_UNHANDLED`. If a derived class implements an async method, it must also implement the corresponding finish method.

## Functions

### g_tls_interaction_invoke_ask_password ()

    GTlsInteractionResult
    g_tls_interaction_invoke_ask_password (GTlsInteraction *interaction,
                                           GTlsPassword *password,
                                           GCancellable *cancellable,
                                           GError **error);

Invoke the interaction to ask the user for a password. It invokes this interaction in the main loop, specifically the GMainContext returned by `g_main_context_get_thread_default()` when the interaction is created. This is called by called by GTlsConnection or GTlsDatabase to ask the user for a password.

Derived subclasses usually implement a password prompt, although they may also choose to provide a password from elsewhere. The `password` value will be filled in and then `callback` will be called. Alternatively the user may abort this password request, which will usually abort the TLS connection.

The implementation can either be a synchronous (eg: modal dialog) or an asynchronous one (eg: modeless dialog). This function will take care of calling which ever one correctly.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

#### Parameters

interaction | a GTlsInteraction object |
password | a GTlsPassword object |
cancellable | an optional GCancellable cancellation object |
error | an optional location to place an error on failure |

#### Returns

The status of the ask password interaction.

Since: 2.30

### g_tls_interaction_invoke_request_certificate ()

    GTlsInteractionResult
    g_tls_interaction_invoke_request_certificate
                                   (GTlsInteraction *interaction,
                                    GTlsConnection *connection,
                                    GTlsCertificateRequestFlags flags,
                                    GCancellable *cancellable,
                                    GError **error);

Invoke the interaction to ask the user to choose a certificate to use with the connection. It invokes this interaction in the main loop, specifically the GMainContext returned by `g_main_context_get_thread_default()` when the interaction is created. This is called by called by GTlsConnection when the peer requests a certificate during the handshake.

Derived subclasses usually implement a certificate selector, although they may also choose to provide a certificate from elsewhere. Alternatively the user may abort this certificate request, which may or may not abort the TLS connection.

The implementation can either be a synchronous (eg: modal dialog) or an asynchronous one (eg: modeless dialog). This function will take care of calling which ever one correctly.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

#### Parameters

interaction | a GTlsInteraction object |
connection | a GTlsConnection object |
flags | flags providing more information about the request |
cancellable | an optional GCancellable cancellation object |
error | an optional location to place an error on failure |

#### Returns

The status of the certificate request interaction.

Since: 2.40

### g_tls_interaction_ask_password ()

    GTlsInteractionResult
    g_tls_interaction_ask_password (GTlsInteraction *interaction,
                                    GTlsPassword *password,
                                    GCancellable *cancellable,
                                    GError **error);

Run synchronous interaction to ask the user for a password. In general, `g_tls_interaction_invoke_ask_password()` should be used instead of this function.

Derived subclasses usually implement a password prompt, although they may also choose to provide a password from elsewhere. The `password` value will be filled in and then `callback` will be called. Alternatively the user may abort this password request, which will usually abort the TLS connection.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

#### Parameters

interaction | a GTlsInteraction object |
password | a GTlsPassword object |
cancellable | an optional GCancellable cancellation object |
error | an optional location to place an error on failure |

#### Returns

The status of the ask password interaction.

Since: 2.30

### g_tls_interaction_ask_password_async ()

    void
    g_tls_interaction_ask_password_async (GTlsInteraction *interaction,
                                          GTlsPassword *password,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Run asynchronous interaction to ask the user for a password. In general, `g_tls_interaction_invoke_ask_password()` should be used instead of this function.

Derived subclasses usually implement a password prompt, although they may also choose to provide a password from elsewhere. The `password` value will be filled in and then `callback` will be called. Alternatively the user may abort this password request, which will usually abort the TLS connection.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

Certain implementations may not support immediate cancellation.

#### Parameters

interaction | a GTlsInteraction object |
password | a GTlsPassword object |
cancellable | an optional GCancellable cancellation object |
callback | will be called when the interaction completes. | [nullable]
user_data | data to pass to the `callback` . | [nullable]

Since: 2.30

### g_tls_interaction_ask_password_finish ()

    GTlsInteractionResult
    g_tls_interaction_ask_password_finish (GTlsInteraction *interaction,
                                           GAsyncResult *result,
                                           GError **error);

Complete an ask password user interaction request. This should be once the `g_tls_interaction_ask_password_async()` completion callback is called.

If `G_TLS_INTERACTION_HANDLED` is returned, then the GTlsPassword passed to `g_tls_interaction_ask_password()` will have its password filled in.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code.

#### Parameters

interaction | a GTlsInteraction object |
result | the result passed to the callback |
error | an optional location to place an error on failure |

#### Returns

The status of the ask password interaction.

Since: 2.30

### g_tls_interaction_request_certificate ()

    GTlsInteractionResult
    g_tls_interaction_request_certificate (GTlsInteraction *interaction,
                                           GTlsConnection *connection,
                                           GTlsCertificateRequestFlags flags,
                                           GCancellable *cancellable,
                                           GError **error);

Run synchronous interaction to ask the user to choose a certificate to use with the connection. In general, `g_tls_interaction_invoke_request_certificate()` should be used instead of this function.

Derived subclasses usually implement a certificate selector, although they may also choose to provide a certificate from elsewhere. Alternatively the user may abort this certificate request, which will usually abort the TLS connection.

If `G_TLS_INTERACTION_HANDLED` is returned, then the GTlsConnection passed to `g_tls_interaction_request_certificate()` will have had its “certificate” filled in.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

#### Parameters

interaction | a GTlsInteraction object |
connection | a GTlsConnection object |
flags | flags providing more information about the request |
cancellable | an optional GCancellable cancellation object |
error | an optional location to place an error on failure |

#### Returns

The status of the request certificate interaction.

Since: 2.40

### g_tls_interaction_request_certificate_async ()

    void
    g_tls_interaction_request_certificate_async
                                   (GTlsInteraction *interaction,
                                    GTlsConnection *connection,
                                    GTlsCertificateRequestFlags flags,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Run asynchronous interaction to ask the user for a certificate to use with the connection. In general, `g_tls_interaction_invoke_request_certificate()` should be used instead of this function.

Derived subclasses usually implement a certificate selector, although they may also choose to provide a certificate from elsewhere. `callback` will be called when the operation completes. Alternatively the user may abort this certificate request, which will usually abort the TLS connection.

#### Parameters

interaction | a GTlsInteraction object |
connection | a GTlsConnection object |
flags | flags providing more information about the request |
cancellable | an optional GCancellable cancellation object |
callback | will be called when the interaction completes. | [nullable]
user_data | data to pass to the `callback` . | [nullable]

Since: 2.40

### g_tls_interaction_request_certificate_finish ()

    GTlsInteractionResult
    g_tls_interaction_request_certificate_finish
                                   (GTlsInteraction *interaction,
                                    GAsyncResult *result,
                                    GError **error);

Complete a request certificate user interaction request. This should be once the `g_tls_interaction_request_certificate_async()` completion callback is called.

If `G_TLS_INTERACTION_HANDLED` is returned, then the GTlsConnection passed to `g_tls_interaction_request_certificate_async()` will have had its “certificate” filled in.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code.

#### Parameters

interaction | a GTlsInteraction object |
result | the result passed to the callback |
error | an optional location to place an error on failure |

#### Returns

The status of the request certificate interaction.

Since: 2.40

## Types and Values

### GTlsInteraction

    typedef struct _GTlsInteraction GTlsInteraction;

An object representing interaction that the TLS connection and database might have with the user.

Since: 2.30

### enum GTlsInteractionResult

GTlsInteractionResult is returned by various functions in GTlsInteraction when finishing an interaction request.

#### Members

G_TLS_INTERACTION_UNHANDLED | The interaction was unhandled (i.e. not implemented). |
G_TLS_INTERACTION_HANDLED | The interaction completed, and resulting data is available. |
G_TLS_INTERACTION_FAILED | The interaction has failed, or was cancelled. and the operation should be aborted. |

Since: 2.30

### enum GTlsCertificateRequestFlags

Flags for `g_tls_interaction_request_certificate()`, `g_tls_interaction_request_certificate_async()`, and `g_tls_interaction_invoke_request_certificate()`.

#### Members

G_TLS_CERTIFICATE_REQUEST_NONE | No flags |

Since: 2.40

### struct GTlsInteractionClass

    struct GTlsInteractionClass {
      GTlsInteractionResult  (* ask_password)        (GTlsInteraction    *interaction,
                                                      GTlsPassword       *password,
                                                      GCancellable       *cancellable,
                                                      GError            **error);

      void                   (* ask_password_async)  (GTlsInteraction    *interaction,
                                                      GTlsPassword       *password,
                                                      GCancellable       *cancellable,
                                                      GAsyncReadyCallback callback,
                                                      gpointer            user_data);

      GTlsInteractionResult  (* ask_password_finish) (GTlsInteraction    *interaction,
                                                      GAsyncResult       *result,
                                                      GError            **error);

      GTlsInteractionResult  (* request_certificate)        (GTlsInteraction              *interaction,
                                                             GTlsConnection               *connection,
                                                             GTlsCertificateRequestFlags   flags,
                                                             GCancellable                 *cancellable,
                                                             GError                      **error);

      void                   (* request_certificate_async)  (GTlsInteraction              *interaction,
                                                             GTlsConnection               *connection,
                                                             GTlsCertificateRequestFlags   flags,
                                                             GCancellable                 *cancellable,
                                                             GAsyncReadyCallback           callback,
                                                             gpointer                      user_data);

      GTlsInteractionResult  (* request_certificate_finish) (GTlsInteraction              *interaction,
                                                             GAsyncResult                 *result,
                                                             GError                      **error);
    };

The class for GTlsInteraction. Derived classes implement the various virtual interaction methods to handle TLS interactions.

Derived classes can choose to implement whichever interactions methods they'd like to support by overriding those virtual methods in their class initialization function. If a derived class implements an async method, it must also implement the corresponding finish method.

The synchronous interaction methods should implement to display modal dialogs, and the asynchronous methods to display modeless dialogs.

If the user cancels an interaction, then the result should be `G_TLS_INTERACTION_FAILED` and the error should be set with a domain of `G_IO_ERROR` and code of `G_IO_ERROR_CANCELLED`.

#### Members

`ask_password` () | ask for a password synchronously. If the implementation returns `G_TLS_INTERACTION_HANDLED`, then the password argument should have been filled in by using `g_tls_password_set_value()` or a similar function. |
`ask_password_async` () | ask for a password asynchronously. |
`ask_password_finish` () | complete operation to ask for a password asynchronously. If the implementation returns `G_TLS_INTERACTION_HANDLED`, then the password argument of the async method should have been filled in by using `g_tls_password_set_value()` or a similar function. |
`request_certificate` () | ask for a certificate synchronously. If the implementation returns `G_TLS_INTERACTION_HANDLED`, then the connection argument should have been filled in by using `g_tls_connection_set_certificate()`. |
`request_certificate_async` () | ask for a certificate asynchronously. |
`request_certificate_finish` () | complete operation to ask for a certificate asynchronously. If the implementation returns `G_TLS_INTERACTION_HANDLED`, then the connection argument of the async method should have been filled in by using `g_tls_connection_set_certificate()`. |

Since: 2.30